/* a ggLCARS ebook reader - Copyright (c) 2004 Greg Alexander */
/* $Id: gread.c,v 1.3 2004/04/14 10:20:31 galexand Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ggl.h>
#include "gread.h"

static struct ggl_window *win;

int
main(void)
{
	state_load();

	ggl_init();

	win = ggl_window_new(320,200);
	win->parent.destroy = (void (*)(struct ggl_widget *))do_quit;
	ggl_window_attach(win, filelist_get());

	ggl_loop();

	return 0;
}

void
read_file(char *fn)
{
	static char *fnbuf = NULL;
	static int fnbuflen = 0;
	int len = strlen(fn) + strlen(EBOOK_DIR) + 2;

	if (fnbuflen < len) {
		fnbuflen = len+100;
		free(fnbuf);
		fnbuf = safe_malloc(fnbuflen);
	}
	sprintf(fnbuf, "%s/%s",EBOOK_DIR,fn);

	state_prime(fn);
	if (reader_load(fnbuf))
		return;

	ggl_register_keys(NULL);
	ggl_window_attach(win, reader_get());

	win->parent.resize((struct ggl_widget *)win, NULL, 0);
	win->parent.redraw((struct ggl_widget *)win);
}

void
do_filelist(void)
{
	ggl_register_keys(NULL);
	ggl_window_attach(win, filelist_get());

	win->parent.resize((struct ggl_widget *)win, NULL, 0);
	win->parent.redraw((struct ggl_widget *)win);
}

void
do_quit(void)
{
	ggl_quit();
	state_save();
}

void *
safe_malloc(int len)
{
	char *p = malloc(len);
	if (!p) {
		fprintf(stderr,"malloc() failed!\n");
		exit(-1);
	}
	return p;
}

char *
safe_strdup(char *s)
{
	int len;
	char *ret;

	if (!s) return NULL;
	len = strlen(s)+1;
	ret = safe_malloc(len);
	memcpy(ret,s,len);
	return ret;
}
